// DlgAlphaTest.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "DlgAlphaTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgAlphaTest dialog

// Definition des index d'opration su l'alpha test
#define INDEX_GL_NEVER			0
#define INDEX_GL_LESS			1
#define INDEX_GL_EQUAL			2
#define INDEX_GL_LEQUAL			3
#define INDEX_GL_GREATER		4
#define INDEX_GL_NOTEQUAL		5
#define INDEX_GL_GEQUAL			6
#define INDEX_GL_ALWAYS			7


CDlgAlphaTest::CDlgAlphaTest(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAlphaTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAlphaTest)
	Seuil = 0.0f;
	bEnable = FALSE;
	//}}AFX_DATA_INIT
	pAlpha = NULL;
	pView = NULL;
}


void CDlgAlphaTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAlphaTest)
	DDX_Control(pDX, IDC_COMBO_OP, Combo);
	DDX_Text(pDX, IDC_EDIT_VAL_COMPARE, Seuil);
	DDX_Check(pDX, IDC_CHECK_ENABLE, bEnable);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgAlphaTest, CDialog)
	//{{AFX_MSG_MAP(CDlgAlphaTest)
	ON_BN_CLICKED(IDC_CHECK_ENABLE, OnCheckEnable)
	ON_EN_CHANGE(IDC_EDIT_VAL_COMPARE, OnChangeEditValCompare)
	ON_CBN_SELCHANGE(IDC_COMBO_OP, OnSelchangeComboOp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAlphaTest message handlers


GLenum CDlgAlphaTest::IndexToOp (int index)
{
	GLenum op;
	switch (index)
	{
		case INDEX_GL_NEVER: op = GL_NEVER;break;
		case INDEX_GL_LESS: op = GL_LESS;break;
		case INDEX_GL_EQUAL: op = GL_EQUAL;break;
		case INDEX_GL_LEQUAL: op = GL_LEQUAL;break;
		case INDEX_GL_GREATER: op = GL_GREATER;break;
		case INDEX_GL_NOTEQUAL: op = GL_NOTEQUAL;break;
		case INDEX_GL_GEQUAL: op = GL_GEQUAL;break;
		case INDEX_GL_ALWAYS: op = GL_ALWAYS;break;
	}
	return op;
}


int CDlgAlphaTest::OpToIndex (GLenum op)
{
	int index = -1;
	switch (index)
	{
		case GL_NEVER: index = INDEX_GL_NEVER;break;
		case GL_LESS: index = INDEX_GL_LESS;break;
		case GL_EQUAL: index = INDEX_GL_EQUAL;break;
		case GL_LEQUAL: index = INDEX_GL_LEQUAL;break;
		case GL_GREATER: index = INDEX_GL_GREATER;break;
		case GL_NOTEQUAL: index = INDEX_GL_NOTEQUAL;break;
		case GL_GEQUAL: index = INDEX_GL_GEQUAL;break;
		case GL_ALWAYS: index = INDEX_GL_ALWAYS;break;
	}
	return index;
}

BOOL CDlgAlphaTest::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (pAlpha == NULL)
	{
		OnCancel ();
		return FALSE;
	}


	// Initialiser les donnes
	Combo.SetCurSel (OpToIndex (pAlpha->GetType ()));
	Seuil = pAlpha->GetSeuil ();
	UpdateData (FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgAlphaTest::OnCheckEnable() 
{
	UpdateData (TRUE);
	if (bEnable)
	{
		UpdateAlphaObject ();
		pAlpha->MakeAlphaTest ();
	}

	if (bEnable) pAlpha->Enable ();
	else pAlpha->Disable ();

}

void CDlgAlphaTest::OnChangeEditValCompare() 
{
	UpdateAlphaObject ();
}

void CDlgAlphaTest::OnSelchangeComboOp() 
{
	UpdateAlphaObject ();
}

void CDlgAlphaTest :: UpdateAlphaObject ()
{
	UpdateData (TRUE);
	pAlpha->SetType (IndexToOp (Combo.GetCurSel ()));
	pAlpha->SetSeuil (Seuil);
	if (pView) pView->Invalidate (FALSE);
}
