// MakeTerrainDoc.h : interface of the CMakeTerrainDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAKETERRAINDOC_H__087325EB_662A_11D3_B45E_000001200881__INCLUDED_)
#define AFX_MAKETERRAINDOC_H__087325EB_662A_11D3_B45E_000001200881__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TerrainType.h"
#include "ObjetTroisD.h"


class CMakeTerrainDoc : public CDocument
{
protected: // create from serialization only
	CMakeTerrainDoc();
	DECLARE_DYNCREATE(CMakeTerrainDoc)


// Attributes
public:

	TextureInfo * pTexture;
	CBitmap BmpLand;

	int Dep;
	
	int Hauteur;
	int Largeur;
	int NbPoint;
//	int HauteurMin;
//	int HauteurMax;
//	int Hmax;
	int NbCase;
	int NbFacette;
	int ip,jp;		// Point courant;
	int imousep,jmousep;		// Pointeur de mouse
	
	POINTASC_TERRE ** Tab;
	FACETTE_TERRE * Face;

	void Reset (BOOL bResetAll = TRUE);
	void SetCurPoint (int ipinit,int jpinit) {ip = ipinit;jp = jpinit;}
	void GetCurPoint (int &ipinit,int &jpinit) {ipinit = ip;jpinit = jp;}
	void SetMousePointeur (int ipinit,int jpinit) {imousep = ipinit;jmousep = jpinit;}
	void GetMousePointeur (int &ipinit,int &jpinit) {ipinit = imousep;jpinit = jmousep;}
	void Render ();

	FACETTE_TERRE * GetFacette (float x,float z);
	POINTASC Normal (float x,float y,float z,float vecx,float vecy,float vecz);


	


// Operations
public:

	void ConfigTerrain ();

	int GetLargeur () {return Largeur;}
	void SetLargeur (int val);

	int GetTotalPoint () {return NbPoint;}
	BOOL SetTotalPoint (int val);

	POINTASC_TERRE * GetPoint (int i,int j);
	FACETTE_TERRE * GetFacette (int i);


//	void HMinMax (int val);
	BOOL Save (CString FileName);
	
	// Fonction d'initialisation
	void InitFacette ();


	
	void Normalise (GLfloat &x,GLfloat &y,GLfloat &z);
	

	// Calcul des normales
	void NormalFacette ();			// Normal de toutes les facettes
	void NormalFacette (int no);	// Normal d'une facette
	void NormalPoint (int i,int j);	// Calcule la normale d'un point

	// Manipulation d'un point
	void ModifPoint (int i,int j);
	void SetPointColor (int i,int j,float val);
	void SetPointY (int i,int j,int Hauteur);
	void SetMultiPointY (int indx,int indy,int np,int Hauteur);

	void toFloat (char * ligne);
	NORMAL * ReadNormal (int i,FILE * pFile);
	Objet * ChargerASEFile(CString FileName);
	GLint GenObjList(Objet * obj);
	void SetTextureCoord (POINTASC * pt);
	void SetNormal (FACETTE * pFacette,int no);
	void SetAleaHauteur (int Alea);

	void SetIdTexture (int ideb,int jdeb,int nFace,int IdTexture,int IndexTexture,BOOL bBlend = FALSE);
	void SetIdTexture (int icase,int jcase,int IdTexture,int IndexTexture);
	void ResetFacetteTexture (int IdTexture);

	BOOL CheckPointByNiveau (POINTASC_TERRE * pt);
	BOOL CheckPointByNiveau (int i,int j);
	BOOL CheckPointInTriangle (float y1,float y2,float y3);

	void Lineariser (void);
	void Random (void);
	float Moyenne (POINTASC_TERRE * pt1,POINTASC_TERRE * pt2,POINTASC_TERRE * pt3,POINTASC_TERRE * pt4);
	void UpdatePointColor ();
	void ApplyTextureAll(int IdTexure,int IndexTexture);
	BOOL NewTerrain (int NbPointInit);
	void FreeMemory();
	BOOL UpdateBitmap2D ();
	BOOL LoadMapping (CString FileName);
	BOOL UpdateLandSacpeByMapping (TextureInfo * pText);

	void NormalPointTmp  (int i,int j);
	int GetAroundFacette(int index,int i,int j);




	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMakeTerrainDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMakeTerrainDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMakeTerrainDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAKETERRAINDOC_H__087325EB_662A_11D3_B45E_000001200881__INCLUDED_)
